#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""The setup script."""

from setuptools import setup, find_packages

with open('README.rst') as readme_file:
    readme = readme_file.read()

with open('HISTORY.rst') as history_file:
    history = history_file.read()


setup(
    author="IRIS PASSCAL",
    author_email='software-support@passcal.nmt.edu',
    classifiers=[
        'Development Status :: 5 - Production/Stable',
        'Intended Audience :: Developers',
        'License :: OSI Approved ::  GNU General Public License v3 (GPLv3)',
        'Natural Language :: English',
        'Programming Language :: Python :: 2.7',
    ],
    description="Download data from Baler14.",
    entry_points={
        'console_scripts': [
            'bline=bline.bline:main',
        ],
    },
    install_requires=[],
    setup_requires = [],
    license="GNU General Public License v3",
    long_description=readme + '\n\n' + history,
    include_package_data=True,
    keywords='bline',
    name='bline',
    packages=find_packages(include=['bline']),
    test_suite='tests',
    url='https://git.passcal.nmt.edu/passoft/bline',
    version='2017.006',
    zip_safe=False,
)
